Bug 713677 - Review Request: klt - An implementation of the Kanade-Lucas-Tomasi feature tracker.
Summary: Review Request: klt - An implementation of the Kanade-Lucas-Tomasi feature tr...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Mario Ceresa
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: vxl
TreeView+ depends on / blocked
 
Reported: 2011-06-16 08:16 UTC by Ankur Sinha (FranciscoD)
Modified: 2016-08-14 16:28 UTC (History)
5 users (show)

Fixed In Version: klt-1.3.4-1.fc16
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-08-03 13:41:19 UTC
Type: ---
mrceresa: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Ankur Sinha (FranciscoD) 2011-06-16 08:16:09 UTC
Spec URL: http://ankursinha.fedorapeople.org/klt/klt.spec
SRPM URL: http://ankursinha.fedorapeople.org/klt/klt-1.3.4-1.fc15.src.rpm

Description: 
KLT is an implementation, in the C programming language, of a feature tracker for the computer vision community.  The source code is in the public domain, available for both commercial and non-commercial use.

The tracker is based on the early work of Lucas and Kanade, was developed fully by Tomasi and Kanade, and was explained clearly in the paper by Shi and Tomasi. Later, Tomasi proposed a slight modification which makes the computation symmetric with respect to the two images -- the resulting equation is derived in the unpublished note by myself.  Briefly, good features are located by examining the minimum eigenvalue of each 2 by 2 gradient matrix, and features are tracked using a Newton-Raphson method of minimizing the difference between the two windows. Multi-resolution tracking allows for relatively large displacements between images. The affine computation that evaluates the consistency of features between non-consecutive frames was implemented by Thorsten Thormaehlen several years after the original code and documentation were written.

================================================================================

rpmlint output:

[ankur@ankur SRPMS]$ rpmlint ../SPECS/klt.spec klt-1.3.4-1.fc15.src.rpm /var/lib/mock/fedora-rawhide-i386/result/*.rpm                               klt.src: W: spelling-error %description -l en_US Multi -> Mulch, Mufti
klt.src: W: spelling-error %description -l en_US affine -> caffeine, fine
klt.i686: E: devel-dependency klt-devel
klt.i686: W: spelling-error %description -l en_US Multi -> Mulch, Mufti
klt.i686: W: spelling-error %description -l en_US affine -> caffeine, fine
klt.i686: E: no-binary
klt.src: W: spelling-error %description -l en_US Multi -> Mulch, Mufti
klt.src: W: spelling-error %description -l en_US affine -> caffeine, fine

^^^ Ignorable

klt-debuginfo.i686: E: empty-debuginfo-package
^^^ Not sure why this is still happening. All the .o files are there :/

klt-devel.i686: W: no-documentation
^^^ Separate documentation folder

6 packages and 1 specfiles checked; 3 errors, 7 warnings.

Thanks!

Comment 1 Mario Ceresa 2011-06-16 08:38:07 UTC
I'll review it!

Comment 2 Ankur Sinha (FranciscoD) 2011-06-16 11:41:58 UTC
I've removed the debuginfo package and commented on the spec. All srpms and specs are updated :)

http://ankursinha.fedorapeople.org/klt/klt.spec

http://ankursinha.fedorapeople.org/klt/klt-1.3.4-1.fc15.src.rpm

Thanks!

Comment 3 Ben Boeckel 2011-06-19 17:07:27 UTC
Don't disable the debuginfo. It just means that the CFLAGS from Fedora aren't being handled properly. The Makefile is probably ignoring what Fedora sets, which isn't acceptable.

Comment 4 Ankur Sinha (FranciscoD) 2011-06-20 02:21:24 UTC
(In reply to comment #3)
> Don't disable the debuginfo. It just means that the CFLAGS from Fedora aren't
> being handled properly. The Makefile is probably ignoring what Fedora sets,
> which isn't acceptable.

I've checked, and the fedora optflags are being honoured. It's because:

"find-debuginfo.sh processes only files that are executable when it's run; for practical purposes one can assume that happens under the hood after the %install section. Make sure that all ELF binaries (executables, shared libraries, DSO's) are executable at end of %install. "

and the static libs are not executable. Are they supposed to be?

thanks,
Ankur

Comment 5 Ben Boeckel 2011-06-20 02:26:57 UTC
Ah. There aren't supposed to be static libraries. They'll need to be built shared.

Comment 6 Ankur Sinha (FranciscoD) 2011-06-20 03:41:11 UTC
Upstream only provides static libraries.

I'm following this:

http://fedoraproject.org/wiki/Packaging:Guidelines#Packaging_Static_Libraries_2

I need these libraries for other packages. Once they're done, I'll work on patching the makefiles to generate shared objects and send the patches upstream. FWIW, I've already mailed upstream regarding this and not received a reply, giving the impression that these libraries are not maintained any more. (They appear pretty old too).

Thanks! :),
Ankur

Comment 7 Ankur Sinha (FranciscoD) 2011-06-27 18:10:18 UTC
Hello,

I've gone ahead and generated shared objects also. 

Fresh srpm/spec: 

http://ankursinha.fedorapeople.org/klt/klt-1.3.4-1.fc15.src.rpm

http://ankursinha.fedorapeople.org/klt/klt.spec

===========================================================================

[ankur@ankur SPECS]$ rpmlint klt.spec ../SRPMS/klt-1.3.4-1.fc15.src.rpm ../RPMS/x86_64/klt-*
klt.src: W: spelling-error %description -l en_US Multi -> Mulch, Mufti
klt.src: W: spelling-error %description -l en_US affine -> caffeine, fine
klt.x86_64: W: spelling-error %description -l en_US Multi -> Mulch, Mufti
klt.x86_64: W: spelling-error %description -l en_US affine -> caffeine, fine
klt.x86_64: W: shared-lib-calls-exit /usr/lib64/libklt.so.1.3.4 exit@GLIBC_2.2.5
klt-devel.x86_64: W: no-documentation
klt-static.x86_64: W: no-documentation
6 packages and 1 specfiles checked; 0 errors, 7 warnings.

Thanks,
Ankur

Comment 8 Ankur Sinha (FranciscoD) 2011-07-18 14:31:44 UTC
I talked to Mario and he said he'll be too busy to review this. Setting to default component.

Comment 9 Mario Ceresa 2011-08-02 09:09:06 UTC
I'll review it!

Legend: + = PASSED, - = FAILED, 0 = Not Applicable

- rpmlint is silent?
klt.x86_64: W: spelling-error %description -l en_US Multi -> Mulch, Mufti
klt.x86_64: W: spelling-error %description -l en_US affine -> caffeine, fine
klt-devel.x86_64: W: no-documentation
klt-static.x86_64: W: no-documentation
those can be ignored

klt.x86_64: W: shared-lib-calls-exit /usr/lib64/libklt.so.1.3.4 exit@GLIBC_2.2.5
here there is not much we can do except report it to the mantainer, if available.

+ The package is named according to the  Package Naming Guidelines.
+ The spec file name matches the base package %{name}, in the format
%{name}.spec.
+ The package meets the Packaging Guidelines.
+ The package is licensed with a Fedora approved license and meets the
Licensing Guidelines.
+ The spec file is written in American English.
+ The spec file for the package is legible.
- The sources used to build the package, match the upstream source, as provided
in the spec URL.
784776f0160acc4f73c88b01bdf88053  http://www.ces.clemson.edu/~stb/klt/klt1.3.4.zip

I cannot check the md5sum for the srpm because the uploaded one is corrupted and won't install. Please re-upload so I can check the mkd5sum

+ The package successfully compiles and builds into binary rpms on at least one
primary architecture. 
http://koji.fedoraproject.org/koji/taskinfo?taskID=3246001

+ All build dependencies are listed in BuildRequires.
0 No need to handle locales.
+ Shared library files are correctly handled (soname + ldconfig)
+ The package does NOT bundle copies of system libraries. 
0 The package is not designed to be relocatable.
+ The package owns all directories that it creates.
+ The package does not list a file more than once in the spec file's %files
listings.
+ Permissions on files are set properly.
+ The package has a %clean section, which contains rm -rf %{buildroot} (or
$RPM_BUILD_ROOT).
+ The package consistently uses macros.
+ The package contains code, or permissible content.
+ No extremely large documentation files.
+ Anything, the package includes as %doc, does not affect the runtime of the
application.
+ Header files are stored in a -devel package.
- No static libraries.
See comment 6 above

+ No pkgconfig(.pc) files.
+ The library file(s) that end in .so (without suffix) is(are) stored in a
*-devel package.
+ The -devel package requires the base package using a fully versioned
dependency: Requires: %{name} = %{version}-%{release}
+ The package does NOT contain any .la libtool archives.
0 Not a GUI application.
+ The package does not own files or directories already owned by other
packages.
+ At the beginning of %install, the package runs rm -rf %{buildroot} (or
$RPM_BUILD_ROOT).
+ All filenames in rpm packages are valid UTF-8.

Please re-upload the srpm so I can check the md5sum of the source files and I'll approve the package

Comment 10 Ankur Sinha (FranciscoD) 2011-08-02 13:03:39 UTC
Hello,

I've uploaded the srpm again. Please have a look:

http://ankursinha.fedorapeople.org/klt/klt-1.3.4-1.fc15.src.rpm

I had modified/patched it to create sonames. Should I remove the static libs altogether? They're in a -static subpackage at the time. 

Thanks,
Ankur

Comment 11 Mario Ceresa 2011-08-03 07:47:59 UTC
Great work!

I propose to leave the static libs for now in the separate package and, when we are able to use vxl without them, we will push an update.

The md5sum of sources are ok:
784776f0160acc4f73c88b01bdf88053 /home/mario/rpmbuild/SOURCES/klt1.3.4.zip
784776f0160acc4f73c88b01bdf88053 http://www.ces.clemson.edu/~stb/klt/klt1.3.4.zip

The package is APPROVED.

Comment 12 Ankur Sinha (FranciscoD) 2011-08-03 12:46:22 UTC
Thank you for the review Mario!

New Package SCM Request
=======================
Package Name: klt
Short Description: An implementation of the Kanade-Lucas-Tomasi feature tracker
Owners: ankursinha
Branches: f14 f15 f16
InitialCC:

Comment 13 Gwyn Ciesla 2011-08-03 12:50:57 UTC
Git done (by process-git-requests).

Comment 14 Ankur Sinha (FranciscoD) 2011-08-03 13:41:19 UTC
Thanks Jon :)

Package built for rawhide, f16, f15, f14. Closing

Comment 15 Fedora Update System 2011-08-03 14:15:24 UTC
klt-1.3.4-1.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/klt-1.3.4-1.fc16

Comment 16 Fedora Update System 2011-08-03 14:17:02 UTC
klt-1.3.4-1.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/klt-1.3.4-1.fc15

Comment 17 Fedora Update System 2011-08-03 14:18:02 UTC
klt-1.3.4-1.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/klt-1.3.4-1.fc14

Comment 18 Fedora Update System 2011-08-13 02:27:36 UTC
klt-1.3.4-1.fc14 has been pushed to the Fedora 14 stable repository.

Comment 19 Fedora Update System 2011-08-13 02:28:39 UTC
klt-1.3.4-1.fc15 has been pushed to the Fedora 15 stable repository.

Comment 20 Fedora Update System 2011-08-22 15:23:05 UTC
klt-1.3.4-1.fc16 has been pushed to the Fedora 16 stable repository.


Note You need to log in before you can comment on or make changes to this bug.